<?php

namespace Teknisa\SM\Factory;

use Doctrine\ORM\EntityManager;

class Sm00001000VendedorPropostaFactory {
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    /**
     * Valida se o vendedor informado já existe para a proposta.
     */
    public function validarSeExisteVendedor($params) {
        $sql = "SELECT COUNT(*) AS EXISTE
                 FROM FCT_VENDEDORORCA
                WHERE NRSEQORCAMENTO  = :NRSEQORCAMENTO
                  AND NRVENDEDORORCA <> :NRVENDEDORORCA
                  AND NRPARCVENDEDOR  = :NRPARCVENDEDOR
                  AND NRORG           = :NRORG";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    /**
     * Valida se existe um vendedor principal para a proposta informada.
     */
    public function validarSeExisteVendedorPrincipal($params) {
        $sql = "SELECT COUNT(*) AS EXISTE
                 FROM FCT_VENDEDORORCA
                WHERE NRSEQORCAMENTO  = :NRSEQORCAMENTO
                  AND NRVENDEDORORCA <> :NRVENDEDORORCA
                  AND NRORG           = :NRORG
                  AND IDVENPRIORCA    = 'S'";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    /**
     * Retorna a soma da porcentagem na participação da venda dos vendedores da proposta.
     */
    public function getPorcentagemVendedores($params) {
        $sql = "SELECT SUM(VRPEPARTICIPAVENDA) AS VRPEPARTICIPAVENDA
                 FROM FCT_VENDEDORORCA
                WHERE NRSEQORCAMENTO = :NRSEQORCAMENTO
                  AND NRORG          = :NRORG";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
}

?>