<?php

namespace Teknisa\SM\Factory;

use Doctrine\ORM\EntityManager;

class Sm00006000ComposicaoServicosFactory {
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    /**
     * Exclui a composição e seus filhos.
     * 
     * @param mixed[] @params
     */
    public function excluirComposicaoEmCascata($params) {
        $sql = "DELETE FROM FCT_COMPSERVICO
                 WHERE NRORG      = :NRORG
                   AND NRCOMPSERVICO IN (SELECT NRCOMPSERVICO
                                          FROM FCT_COMPSERVICO
                                         WHERE NRORG                  = :NRORG
                                         START WITH NRCOMPSERVICO     = :NRCOMPSERVICO
                                       CONNECT BY PRIOR NRCOMPSERVICO = NRCOMPSERVICOPAI)";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    /**
     * Replica o IDATIVO para todos os filhos da composição de serviço alterada
    **/
    public function replicarAlteracaoIdAtivo(array $params){
        $sql = "UPDATE FCT_COMPSERVICO
                SET IDATIVO      = :IDATIVO,
                    CDOPERULTATU = :CDOPERADOR,
                    NRORGULTATU  = :NRORG
                WHERE NRORG = :NRORG
                    AND NRCOMPSERVICO IN(SELECT NRCOMPSERVICO
                                          FROM FCT_COMPSERVICO
                                          CONNECT BY PRIOR NRCOMPSERVICO = NRCOMPSERVICOPAI
                                          START WITH NRCOMPSERVICO       = :NRCOMPSERVICO)";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
}

?>