<?php

namespace Teknisa\SM\Util\Procedure;

use Doctrine\DBAL\Connection;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;

class FctCancVencPrevCont {
    
    const NOME = "FCT_CANC_VENCPREV_CONT";
    private $connection;
    
    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }
    
    /**
     * Executa a procedure.
     * 
     * @param integer $nrorg
     * @param string $idorcacontr
     * @param integer $nrseq
     * 
     * @return string
     */
    public function executar($nrseqcontrato, $nrorg) {
        $procedure = new StoredProcedure($this->connection, self::NOME);
        
        $procedure->addParam(new Param("P_NRSEQCONTRATO",   Param::PARAM_INPUT,  $nrseqcontrato ,   Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param("P_NRORG",           Param::PARAM_INPUT,  $nrorg,            Param::PARAM_TYPE_INT));
        
        $procedure->execute();
    }
    
}

?>