/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_NATURESU                                                 */
/* Tabela : NATURESU                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_NATURESU' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_NATURESU
GO

CREATE TRIGGER DTULTATU_NATURESU
ON NATURESU
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'NATURESU', null, 'CDNATURESU='+ CDNATURESU+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE NATURESU
      SET DTULTATUNRES = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(NATURESU.CDNATURESU,0) = ISNULL(INSERTED.CDNATURESU,0)) AND
            (ISNULL(NATURESU.NMNATURESU,0) = ISNULL(INSERTED.NMNATURESU,0));
   END;
END;
GO

